    
    #include <Wire.h>  // библиотека для работы с I2C-расширителем портов
    #include <Strela.h>  // библиотека Strela
    #include <LiquidCrystal_I2C.h>  // Подключим библиотеку для работы с LCD-эраном через I2C
   LiquidCrystal_I2C lcd(LC_ADDR, LCEN, LCRW, LCRS, LC4, LC5, LC6, LC7);  // Создадим объект lcd, который будет выводить текст на экран
   
#define SIGN_PIN  P9
#define LED_PIN  P11

int  f=0;
int  b=0;
int  K=0;
int  N=0;
int  S=0;
float  t=0;
 
    void setup()
    {
 uPinMode(SIGN_PIN, INPUT); //
 uPinMode(LED_PIN, OUTPUT);
  digitalWrite(LED_PIN, HIGH);
  //Инициализация экрана. У нашего экрана 20 символов 4 строки
  lcd.begin(20, 4);
  
  //Переместим курсор в начало первой строки (символ 0, строка 1)
  lcd.home();
  //Печатаем строку
  lcd.print("       TARGET");
  //Переместим строку в начало второй строки (символ 0, строка 1)
  lcd.setCursor(0, 2);
  //Печатаем строку
  lcd.print("       STRELA");
    delay(5000);//Пауза
    tone(BUZZER, 1000, 1000);//сигнал внимание
     lcd.clear(); //Очищаем экран
    lcd.setCursor(0, 0);
    lcd.print(" TIME         sec");//Печатаем строку
  lcd.setCursor(0, 2);
   lcd.print(" SCORE 0        S/T "); //Печатаем строку
    }
    
     void loop() 
    {
    digitalWrite(LED_PIN, HIGH); 
   lcd.setCursor(7, 0);
   t = millis()/1000-5;
   if (t>=60)
    {
   t = t/60;
   lcd.setCursor(14, 0);
  //Печатаем строку
  lcd.print("min");
    } 
 lcd.setCursor(7, 0);
 lcd.print(t);
 
    f=random(1,5)*10; //пауза вперед
    b=random(1,5)*10; //пауза назад
   
      // Шаговый двигатель управляется при помощи
      // функции stepperMotor(int stepsToMove, int stepDelay);
      // stepsToMove — это количество шагов которые должен
      // сделать шаговый двигатель. 
      // Если это число положительное — мотор крутится в одну сторону,
      // если отрицательное - в другую.
    
      // шагаем  вперед-назад со случайной паузой
    K = N++; 
     if (K<0)
    {
    stepperMotor(2, f);
    }
    if (K>0)
    {
    stepperMotor(-2, b);
    } 
if (K>100)
{
  N=-100;
}

int sign = analogRead(SIGN_PIN); // считываем уровень сигнала
 boolean Zero = (sign < 500); // сравниваем уровень сигнала с порогом
  if (Zero) { // принимаем решение
     // включаем зеленый светодиод - разрешение стрельбы
     }
     else {
    digitalWrite(LED_PIN, LOW); // включаем красный светодиод - запрет стрельбы
    S=S+1;
    lcd.setCursor(7, 2);
  //Печатаем строку
  lcd.print(S);
  tone(BUZZER, 1000, 500);
 delay(500);
 tone(BUZZER, 500, 500);
    delay(500);
    tone(BUZZER, 300, 500);
    delay(500);
    }
      lcd.setCursor(11, 2);
  //Печатаем строку
  lcd.print(S/t);  


if (millis()> 120000) //ограничение продолжительности одного цикла
{
  while(1);
}
  }

   
       
      
     
